%define		nvidialibdir      %{_libdir}/nvidia
%define		nvidialibdir32bit %{_prefix}/lib/nvidia

%{!?kversion: %define kversion `uname -r`}
BuildArchitectures: i586

Name:		xorg-x11-drv-nvidia
Version:	96.43.07
Release:	b1
License:	Distributable
URL:		http://www.nvidia.com/
Group:		User Interface/X Hardware Support
Summary:	Nvidia Display Driver and OpenGL libraries

Source0:	ftp://download.nvidia.com/XFree86/Linux-x86/96.43.07/NVIDIA-Linux-x86-96.43.07-pkg0.run
Source1:	ftp://download.nvidia.com/XFree86/Linux-x86_64/96.43.07/NVIDIA-Linux-x86_64-96.43.07-pkg2.run
Source2:	nvidia-glx.sh
Source3:	nvidia-glx.csh
#Patch0:		NVIDIA_kernel-96.43.05-2.6.26.diff

Requires(post):	chkconfig
Requires(post):	ldconfig
Requires(preun): chkconfig
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
#ExclusiveArch:	i386 x86_64

%description
This package provides Nvidia hardware accelerated OpenGL support
for Nvidia chipsets from Geforce2, Quadro4 or newer.


%package devel
Summary:	Nvidia OpenGL Headers
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
This package provides the Nvidia OpenGL headers and libraries required
for development.


%prep
%setup -q -c -T
sh %{SOURCE0} --extract-only --target nvidiapkg-x86
sh %{SOURCE1} --extract-only --target nvidiapkg-x64
#tar -cvjf nvidia-glx-kmod-data-1.0.8178.tar.bz2 nvidiapkg-*/LICENSE nvidiapkg-*/usr/src/
%ifarch %{ix86}
ln -s nvidiapkg-x86 nvidiapkg
%else
ln -s nvidiapkg-x64 nvidiapkg
%endif
mv nvidiapkg/LICENSE nvidiapkg/usr/share/doc/
# More docs
find nvidiapkg/usr/share/doc/ -type f | xargs chmod 0644

# Module
#pushd nvidiapkg/
#%patch0 -p1
#popd
ksrc=/lib/modules/%{kversion}/build
pushd nvidiapkg/usr/src/nv/
ln -s -f Makefile.kbuild Makefile
make SYSSRC="${ksrc}" module
popd


%install
rm -rf $RPM_BUILD_ROOT

#find nvidiapkg/ -name "*.so*" | xargs strip --strip-unneeded
install -D -m 0644 nvidiapkg/usr/src/nv/nvidia.ko $RPM_BUILD_ROOT/lib/modules/%{kversion}/kernel/drivers/char/drm/nvidia.ko
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/kernel/drivers/char/drm/*

set +x
for file in $(cd nvidiapkg &> /dev/null; find . -type f | grep -v -e 'makeself.sh$' -e 'mkprecompiled$' -e 'tls_test$' -e 'tls_test_dso.so$' -e 'nvidia-settings.desktop$' -e '^./Makefile'  -e '^./nvidia-installer' -e '^./pkg-history.txt' -e '^./.manifest' -e '/usr/share/doc/' -e 'libGL.la$' -e 'drivers/nvidia_drv.o$' -e 'nvidia-installer.1.gz$' -e '^./usr/src/')
do
  if [[ ! "/${file##./usr/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir}/${file##./usr/lib/}
  elif [[ ! "/${file##./usr/X11R6/lib/modules/extensions}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/extensions/nvidia/${file##./usr/X11R6/lib/modules/extensions}
  elif [[ ! "/${file##./usr/X11R6/lib/modules}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/${file##./usr/X11R6/lib/modules}
  elif [[ ! "/${file##./usr/X11R6/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir}/${file##./usr/X11R6/lib/}
  elif [[ ! "/${file##./usr/include/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_includedir}/nvidia/${file##./usr/include/}
  elif [[ ! "/${file##./usr/bin/}" = "/${file}" ]]
  then
    if [[ ! "/${file##./usr/bin/nvidia-xconfig}" = "/${file}" ]]
    then
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/usr/sbin/${file##./usr/bin/}
    elif [[ ! "/${file##./usr/bin/nvidia-bug-report.sh}" = "/${file}" ]]
    then
      install -D -p -m 0755 nvidiapkg/${file} nvidiapkg/usr/share/doc/${file##./usr/bin/}
    else
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/${file}
    fi
  elif [[ ! "/${file##./usr/lib32}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/${file##./usr/lib32/}
  elif [[ ! "/${file##./usr/share/man/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_mandir}/${file##./usr/share/man/}
    gunzip $RPM_BUILD_ROOT/%{_mandir}/${file##./usr/share/man/}
  elif [[ ! "/${file##./usr/share/pixmaps/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/usr/share/pixmaps/${file##./usr/share/pixmaps/}
  else
    echo ${file} found -- don\'t know how to handle
    exit 1
  fi
done
set -x

# Fixme: should we do this directly in above for-loop? Yes, we should! No, please don't!
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir}/libGLcore.so
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir}/libGLcore.so.1
ln -s libGL.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir}/libGL.so.1
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir}/libnvidia-tls.so.1
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir}/tls/libnvidia-tls.so.1
ln -s libnvidia-cfg.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir}/libnvidia-cfg.so.1
ln -s libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libXvMCNVIDIA.so
ln -s libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libXvMCNVIDIA_dynamic.so.1
ln -s libglx.so.%{version} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/extensions/nvidia/libglx.so

# 32-bit libs on x86_64
%ifarch x86_64
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGLcore.so
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGLcore.so.1
ln -s libGL.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGL.so.1
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libnvidia-tls.so.1
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/tls/libnvidia-tls.so.1
ln -s libnvidia-cfg.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libnvidia-cfg.so.1
%endif # x86_64

# profile.d files
install -D -m 0755 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/nvidia-glx.sh
install -D -m 0755 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/nvidia-glx.csh

# Desktop entry for nvidia-settings
install -D -m 0644 nvidiapkg/usr/share/applications/nvidia-settings.desktop $RPM_BUILD_ROOT%{_datadir}/applications/nvidia-settings.desktop

# ld.so.conf.d file
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/
echo "%{nvidialibdir}" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%ifarch x86_64
echo "%{nvidialibdir32bit}" >> $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%endif

mkdir -p $RPM_BUILD_ROOT/usr/X11R6/lib/modules/extensions/nvidia/
install -D -m 0755 nvidiapkg/usr/X11R6/lib/modules/extensions/libglx.so.* $RPM_BUILD_ROOT/usr/X11R6/lib/modules/extensions/nvidia/
ln -s libglx.so.%{version} $RPM_BUILD_ROOT/usr/X11R6/lib/modules/extensions/nvidia/libglx.so

sed -e 's:__UTILS_PATH__:/usr/bin:' -i $RPM_BUILD_ROOT/usr/share/applications/nvidia-settings.desktop
#sed -e 's:__DOCS_PATH__:/usr/share/doc/NVIDIA_GLX-1.0:' -i $RPM_BUILD_ROOT/usr/share/applications/nvidia-settings.desktop
sed -e 's:__PIXMAP_PATH__/nvidia-settings.png:package_settings.png:' -i $RPM_BUILD_ROOT/usr/share/applications/nvidia-settings.desktop


%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
# Add the /etc/modprobe.conf entries one at a time in the event
# one or the other is present or not present
if [ -z "`grep -E -e "^alias +[^ ]+ +(nvidia|NVdriver)" %{_sysconfdir}/modprobe.conf`" ]; then
    echo "alias char-major-195* nvidia" >> %{_sysconfdir}/modprobe.conf
fi
#if [ -z "`grep -E -e "^options +[^ ]+ +(NVreg_ModifyDeviceFiles)" %{_sysconfdir}/modprobe.conf`" ]; then
#    echo "options nvidia NVreg_ModifyDeviceFiles=0" >> %{_sysconfdir}/modprobe.conf
#fi

%preun
if [ "$1" -eq "0" ]; then
    # Remove all entries of nvidia/NVdriver from modprobe.conf
    # Make a backup of the backup
    if [ -f %{_sysconfdir}/modprobe.conf.backup-nvidia-glx ]; then
      mv %{_sysconfdir}/modprobe.conf.backup-nvidia-glx %{_sysconfdir}/modprobe.conf.backup-nvidia-glx-old  || :
    fi
    mv %{_sysconfdir}/modprobe.conf %{_sysconfdir}/modprobe.conf.backup-nvidia-glx || :
    grep -v -E -e "^alias +[^ ]+ +(nvidia|NVdriver)" -e "options nvidia " %{_sysconfdir}/modprobe.conf.backup-nvidia-glx > %{_sysconfdir}/modprobe.conf  || :
fi || :

%postun -p /sbin/ldconfig


%files
%defattr(644,root,root,755)
/lib/modules/*/kernel/drivers/char/drm/*
%defattr(-,root,root,-)
#%doc nvidiapkg/usr/share/doc/*
%dir %{nvidialibdir}
%dir %{nvidialibdir}/tls
#%dir %{_libdir}/xorg/modules/extensions/nvidia
%{nvidialibdir}/*.so.*
%{nvidialibdir}/tls/*.so.*
%{_sysconfdir}/profile.d/nvidia*
%{_libdir}/xorg/modules/drivers/nvidia_drv.so
#%{_libdir}/xorg/modules/extensions/nvidia/*
/usr/X11R6/lib/modules/extensions/nvidia/*
%{_bindir}/*
%{_sbindir}/*
%{_datadir}/applications/*nvidia-settings.desktop
%config %{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%ifarch x86_64
%dir %{nvidialibdir32bit}
%dir %{nvidialibdir32bit}/tls
%{nvidialibdir32bit}/*.so.*
%{nvidialibdir32bit}/tls/*.so.*
%endif  #x86_64

%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/nvidia
%dir %{_includedir}/nvidia/GL
%{_includedir}/nvidia/GL/*.h
%{nvidialibdir}/libXvMCNVIDIA.a
%{nvidialibdir}/*.so
%ifarch x86_64
%{nvidialibdir32bit}/*.so
%endif #x86_64


%changelog
* Wed Sep 17 2008 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 96.43.05
* Mon Jun 11 2007 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 1.0.9639
* Fri Dec 1 2006 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 1.0.9629
* Mon Oct 9 2006 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 1.0.9625
* Thu Jun 29 2006 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 1.0.8762
* Thu Apr 27 2006 Yuichiro Nakada <berry@po.yui.mine.nu>
- Create for Berry Linux
